<?php
// DbType.php
// Created: 2021-05-02
// Updated: 2021-05-04

namespace Index\Data;

/**
 * Map of common database types.
 */
final class DbType {
    /**
     * Automatically detect the type. Should be used in combination with DbTools::detectType.
     *
     * @var int
     */
    public const AUTO = 0;

    /**
     * Represents a NULL value. If this type is specified, the value it was associated with should be overriden with NULL.
     *
     * @var int
     */
    public const NULL = 1;

    /**
     * An integer type.
     *
     * @var int
     */
    public const INTEGER = 2;

    /**
     * A double precision floating point.
     *
     * @var int
     */
    public const FLOAT = 3;

    /**
     * A textual string.
     *
     * @var int
     */
    public const STRING = 4;

    /**
     * Binary blob data.
     *
     * @var int
     */
    public const BLOB = 5;
}
