<?php
// NullDbConnection.php
// Created: 2021-05-02
// Updated: 2022-02-27

namespace Index\Data\NullDb;

use Index\Data\IDbConnection;
use Index\Data\IDbStatement;
use Index\Data\IDbResult;

/**
 * Represents a dummy database connection.
 */
class NullDbConnection implements IDbConnection {
    public function getLastInsertId(): int|string {
        return 0;
    }

    public function prepare(string $query): IDbStatement {
        return new NullDbStatement;
    }

    public function query(string $query): IDbResult {
        return new NullDbResult;
    }

    public function execute(string $query): int|string {
        return 0;
    }

    public function close(): void {}
}
