<?php
// NullDbStatement.php
// Created: 2021-05-02
// Updated: 2022-02-16

namespace Index\Data\NullDb;

use Index\Data\DbType;
use Index\Data\IDbResult;
use Index\Data\IDbStatement;

/**
 * Represents a dummy database statement.
 */
class NullDbStatement implements IDbStatement {
    public function getParameterCount(): int {
        return 0;
    }

    public function addParameter(int $ordinal, mixed $value, int $type = DbType::AUTO): void {}

    public function getResult(): IDbResult {
        return new NullDbResult;
    }

    public function getLastInsertId(): int|string {
        return 0;
    }

    public function execute(): void {}

    public function reset(): void {}

    public function close(): void {}
}
