<?php
// IfUnmodifiedSinceHeader.php
// Created: 2022-02-14
// Updated: 2022-02-14

namespace Index\Http\Headers;

use DateTimeInterface;
use Index\DateTime;
use Index\Http\HttpHeader;

class IfUnmodifiedSinceHeader {
    private DateTime $dateTime;

    public function __construct(DateTime $dateTime) {
        $this->dateTime = $dateTime;
    }

    public function getDateTime(): DateTime {
        return $this->dateTime;
    }

    public function isMoreThan(DateTimeInterface $dateTime): bool {
        return $this->dateTime->isMoreThan($dateTime);
    }

    public static function parse(HttpHeader $header): IfUnmodifiedSinceHeader {
        return new IfUnmodifiedSinceHeader(DateTime::createFromFormat(\DateTimeInterface::RFC7231, $header->getFirstLine()));
    }
}
