<?php
// LastModifiedHeader.php
// Created: 2022-02-14
// Updated: 2022-02-14

namespace Index\Http\Headers;

use Index\DateTime;
use Index\Http\HttpHeader;

class LastModifiedHeader {
    private DateTime $dateTime;

    public function __construct(DateTime $dateTime) {
        $this->dateTime = $dateTime;
    }

    public function getDateTime(): DateTime {
        return $this->dateTime;
    }

    public static function parse(HttpHeader $header): LastModifiedHeader {
        return new LastModifiedHeader(DateTime::createFromFormat(\DateTimeInterface::RFC7231, $header->getFirstLine()));
    }
}
