<?php
// TransferEncodingHeader.php
// Created: 2022-02-14
// Updated: 2022-02-27

namespace Index\Http\Headers;

use Index\Http\HttpHeader;

class TransferEncodingHeader {
    private array $encodings;

    public function __construct(array $encodings) {
        $this->encodings = $encodings;
    }

    public function getEncodings(): array {
        return $this->encodings;
    }

    public static function parse(HttpHeader $header): TransferEncodingHeader {
        return new TransferEncodingHeader(
            array_map(
                fn($directive) => trim($directive),
                explode(',', strtolower($header->getFirstLine()))
            )
        );
    }
}
