<?php
// UpgradeInsecureRequestsHeader.php
// Created: 2022-02-14
// Updated: 2022-02-14

namespace Index\Http\Headers;

use Index\Http\HttpHeader;

class UpgradeInsecureRequestsHeader {
    private bool $upgrade;

    public function __construct(bool $upgrade) {
        $this->upgrade = $upgrade;
    }

    public function shouldUpgrade(): bool {
        return $this->upgrade;
    }

    public static function parse(HttpHeader $header): UpgradeInsecureRequestsHeader {
        return new UpgradeInsecureRequestsHeader($header->getFirstLine() === '1');
    }
}
