<?php
// UserAgentHeader.php
// Created: 2022-02-14
// Updated: 2022-02-27

namespace Index\Http\Headers;

use Stringable;
use Index\Http\HttpHeader;

class UserAgentHeader implements Stringable {
    private string $userAgent;

    public function __construct(string $userAgent) {
        $this->userAgent = $userAgent;
    }

    public function getUserAgent(): string {
        return $this->userAgent;
    }

    public function __toString(): string {
        return $this->userAgent;
    }

    public static function parse(HttpHeader $header): UserAgentHeader {
        return new UserAgentHeader(trim($header->getFirstLine()));
    }
}
